<?php
/**
 * NOTICE OF LICENSE
 *
 * This file is licenced under the Software License Agreement.
 * With the purchase or the installation of the software in your application
 * you accept the licence agreement.
 *
 * You must not modify, adapt or create derivative works of this source code
 *
 *  @author    Luís Gonçalves
 *  @copyright 2015-2016 PayPay
 *  @license   LICENSE.txt
 */

class CardRequestReferenceDetails
{
    /** @var Int */
    public $amount;

    /** @var String */
    public $reference;

    /** @var Int */
    public $paymentId;

    /** @var String */
    public $productCode;

    /** @var String */
    public $productDesc;

    /** @var String */
    public $validStartDate;

    /** @var String */
    public $validEndDate;

    public $idPlatformCode;

    public $expirationDate;

    /**  @var RequestPaymentOption[] */
    public $paymentOptions;

    /** @var String */
    public $bankAccountCode;

    /** @var RequestBuyerInfo */
    public $buyer;

    /** @var RequestBillingAddress */
    public $billingAddress;

    /** @var RequestShippingAddress */
    public $shippingAddress;

    public function __construct($data)
    {
        $this->amount           = !empty($data['amount']) ? $data['amount']:'';
        $this->productCode      = !empty($data['productCode']) ? $data['productCode']:'';
        $this->productDesc      = !empty($data['productDesc']) ? $data['productDesc']:'';
        $this->reference        = !empty($data['reference']) ? $data['reference']:'';
        $this->paymentId        = !empty($data['paymentId']) ? $data['paymentId']:'';
        $this->idPlatformCode   = !empty($data['idPlatformCode']) ? $data['idPlatformCode']:'';
        $this->validStartDate   = !empty($data['validStartDate']) ? $data['validStartDate']:null;
        $this->validEndDate     = !empty($data['validEndDate']) ? $data['validEndDate']:null;
        $this->expirationDate   = !empty($data['expirationDate']) ? $data['expirationDate']:'';
        $this->paymentOptions   = !empty($data['paymentOptions']) ? $data['paymentOptions']: null;
        $this->bankAccountCode  = !empty($data['bankAccountCode']) ? $data['bankAccountCode'] : null;
        $this->buyer            = !empty($data['buyer']) ? $data['buyer']:null;
        $this->billingAddress   = !empty($data['billingAddress']) ? $data['billingAddress']:null;
        $this->shippingAddress  = !empty($data['shippingAddress']) ? $data['shippingAddress']:null;
    }
}
